function BadKitty_OLoad(panel)
	SlashCmdList["BADKITTY"] = BadKitty_Slashes
	SLASH_BADKITTY1 = "/badkitty"
	SLASH_BADKITTY2 = "/bk"
	--[[BadKittyOptionsCheckOOCWarnings:SetChecked(BadKittySaves[4])
	if not BadKittyOptionsCheckOOCWarnings:GetChecked() then
		BadKittyOptionsCheckOOCBars:SetChecked()
	end]]
	panel.name = "BadKitty"
	InterfaceOptions_AddCategory(panel)
	StaticPopupDialogs["BADKITTY_OLDVERSION"] = {
	text="You have just upgraded to BadKitty 1.6!  There's a ton of new stuff, so you should do yourself a favor and head over to the Options Menu.  Just type /bk!",
	button1="Ok!",
	timeout=0,
	whileDead=1,
	hideOnEscape=1}
end

function BadKitty_OpenOptions()
	InterfaceOptionsFrame_OpenToCategory(BadKittyColorOptions)
	InterfaceOptionsFrame_OpenToCategory(BadKittyOptions)
end

function BadKitty_OptionsLoad(panel,name)	--Only for children!
	panel.name = name
	panel.parent = "BadKitty"
	InterfaceOptions_AddCategory(panel)
end

function BadKitty_Slashes(msg)
	if msg == "0" then
		ReloadUI();
		return 0;
	end
	if msg=="toggle" then
		if BadKittySaves[5]==1 or BadKittySaves[9]==1 then
			BadKittySaves[5]=0
			BadKittySaves[8]=0
			BadKittySaves[9]=0
			BadKittySaves[11]=0
		else
			BadKittySaves[5]=1
			BadKittySaves[8]=1
			BadKittySaves[9]=1
			BadKittySaves[11]=1
		end
		return 0
	elseif msg=="lock" then
		if BadKittyLock==1 then
			BadKittyOptionsCheckLock:SetChecked(0)
			BadKittyLock=0
		else
			BadKittyOptionsCheckLock:SetChecked(1)
			BadKittyLock=1
		end
		BadKitty_Lock()
		return
	end
	InterfaceOptionsFrame_OpenToCategory(BadKittyColorOptions)
	InterfaceOptionsFrame_OpenToCategory(BadKittyOptions)
	--[[
	local a,b=strfind(msg, "%S+")
	Cmd = strsub(msg,a,b)
	Sub = strsub(msg,b+2)
	if Cmd == "toggle" then
		if BadKittySaves[9]==1 or BadKittySaves[11]==1 then
			BadKittySaves[9]=0
			BadKittySaves[11]=0
		else
			BadKittySaves[9]=1
			BadKittySaves[11]=1
		end
	end]]
end 

--------

function BadKitty_Font()
	local size = BadKittyOptionsFont:GetValue()
	BadKittySaves[6] = size
	BadKitty_Setup()
end

function BadKitty_RatioToggle()
	if this:GetChecked() then
		BadKittySaves[4]=1
	else
		BadKittySaves[4]=0
	end
	BadKitty_Setup()
end

function BadKitty_Resize()
	local width = BadKittyOptionsWidth:GetValue()
	local height = BadKittyOptionsHeight:GetValue()
	if height then
		BadKittySaves[1] = height
	end
	if width then
		BadKittySaves[2] = width
	end
	BadKitty_SetFrames()
end

function BadKitty_CombatHide()
	if this:GetChecked() then
		BadKittySaves[7]=1
	else
		BadKittySaves[7]=0
	end
end

function BadKitty_CWarn()
	if this:GetChecked() then
		BadKittySaves[11] = 1
	else
		BadKittySaves[11] = 0
	end
end

function BadKitty_CBar()
	if this:GetChecked() then
		BadKittySaves[9] = 1
	else
		BadKittySaves[9] = 0
	end
end

function BadKitty_BWarn()
	if this:GetChecked() then
		BadKittySaves[8] = 1
	else
		BadKittySaves[8] = 0
	end
end

function BadKitty_BBar()
	if this:GetChecked() then
		BadKittySaves[5] = 1
	else
		BadKittySaves[5] = 0
	end
end

function BadKitty_Lock()
	if BadKittyOptionsCheckLock:GetChecked() then
		BadKittyLock = 1
		BKWMoveFrame:EnableMouse(0)
		BKWMoveFrame:SetAlpha(0)
		BKWBearMoveFrame:EnableMouse(0)
		BKWBearMoveFrame:SetAlpha(0)
		BadKittySaves[7]=BadKittyTempHide
	else
		BadKittyLock = 0
		BKWMoveFrame:EnableMouse(1)
		BKWMoveFrame:SetAlpha(1)
		BKWBearMoveFrame:EnableMouse(1)
		BKWBearMoveFrame:SetAlpha(1)
		BadKittyTempHide=BadKittySaves[7]
		BadKittySaves[7]=0
	end
end

function BadKitty_OOCToggle()
	if this:GetChecked() then
		BadKittySaves[10] = 1
	else
		BadKittySaves[10] = 0
	end
end

function BadKitty_OOCPosition()
	if BadKittyOptionsCheckOOCBars:GetChecked() then
		BadKittySaves[4] = 1
	else
		BadKittySaves[4] = 0 
	end
	BadKitty_Setup()
end

function BadKitty_CenterFrame()
	BadKittyFrame:ClearAllPoints()
	BadKittyFrame:SetPoint("CENTER", "UIParent", "CENTER")
	BadKittyWarnings:ClearAllPoints()
	BadKittyWarnings:SetPoint("CENTER", "UIParent", "CENTER")
	BadKittyBear:ClearAllPoints()
	BadKittyBear:SetPoint("CENTER", "UIParent", "CENTER")
	BadKittyBearWarnings:ClearAllPoints()
	BadKittyBearWarnings:SetPoint("CENTER", "UIParent", "CENTER")
	
end

function BKMove()
	if BadKittyLock == 0 then
		BadKittyFrame:StartMoving()
	end
end 

function BKBMove()
	if BadKittyLock == 0 then
		BadKittyBear:StartMoving()
	end
end 

function BKWMove()
	if BadKittyLock == 0 then
		BadKittyWarnings:StartMoving()
	end
end 

function BKWBearMove()
	if BadKittyLock == 0 then
		BadKittyBearWarnings:StartMoving()
	end
end 

function BadKitty_Timer()
	BadKittySaves[12] = BadKittyOptionsTimer:GetValue()
end

function BadKitty_HideBear()
	BadKittyBear:Hide()
	BadKittyBearWarnings:Hide()
end 

function BadKitty_BarOrder(bar,action,formTable)
	BadKittyBarOptionsCatText0:Hide()
	BadKittyBarOptionsBearText0:Hide()
	if action=="UP" then
		maxj=1
		for i,j in ipairs(formTable) do 
			if j==bar then current = i end
			if j==bar-1 then previous = i end
			if j>maxj then maxj = j end
		end
		formTable[current]=bar-1
		formTable[previous]=bar
	elseif action=="DOWN" then
		for i,j in ipairs(formTable) do 
			if j==bar then current = i end
			if j==bar+1 then nexti = i end
		end
		formTable[current]=bar+1
		formTable[nexti]=bar
	end
	BadKitty_SetFrames()
	BadKitty_BarOptionsText()
end 

function BadKitty_BarOptionsText()
	local _G = getfenv()
	for i,j in ipairs(BadKittyCFrames) do
		if 		i==1 then _G["BadKittyBarOptionsCatText"..j]:SetText("Savage Roar")
		elseif	i==2 then _G["BadKittyBarOptionsCatText"..j]:SetText("Mangle")
		elseif	i==3 then _G["BadKittyBarOptionsCatText"..j]:SetText("Rake")
		elseif	i==4 then _G["BadKittyBarOptionsCatText"..j]:SetText("Rip")
		elseif	i==5 then _G["BadKittyBarOptionsCatText"..j]:SetText("Faerie Fire")
		elseif	i==6 then _G["BadKittyBarOptionsCatText"..j]:SetText("Combos")
		elseif	i==7 then _G["BadKittyBarOptionsCatText"..j]:SetText("Tiger's Fury")
		elseif	i==8 then _G["BadKittyBarOptionsCatText"..j]:SetText("Berserk")
		elseif	i==9 then _G["BadKittyBarOptionsCatText"..j]:SetText("Energy")
		end
	end
	for i,j in ipairs(BadKittyBFrames) do
		if 		i==1 then _G["BadKittyBarOptionsBearText"..j]:SetText("Mangle")
		elseif	i==2 then _G["BadKittyBarOptionsBearText"..j]:SetText("Demo Roar")
		elseif	i==3 then _G["BadKittyBarOptionsBearText"..j]:SetText("Lacerate")
		elseif	i==4 then _G["BadKittyBarOptionsBearText"..j]:SetText("Faerie Fire")
		elseif	i==5 then _G["BadKittyBarOptionsBearText"..j]:SetText("Barkskin")
		elseif	i==6 then _G["BadKittyBarOptionsBearText"..j]:SetText("Berserk")
		elseif	i==7 then _G["BadKittyBarOptionsBearText"..j]:SetText("Rage")
		end
	end
end 

function BadKitty_CatRadioOff()
	BadKittyBarOptionsCatRadio1:SetChecked(0)
	BadKittyBarOptionsCatRadio2:SetChecked(0)
	BadKittyBarOptionsCatRadio3:SetChecked(0)
	BadKittyBarOptionsCatRadio4:SetChecked(0)
	BadKittyBarOptionsCatRadio5:SetChecked(0)
	BadKittyBarOptionsCatRadio6:SetChecked(0)
	BadKittyBarOptionsCatRadio7:SetChecked(0)
	BadKittyBarOptionsCatRadio8:SetChecked(0)
	BadKittyBarOptionsCatRadio9:SetChecked(0)
end

function BadKitty_BearRadioOff()
	BadKittyBarOptionsBearRadio1:SetChecked(0)
	BadKittyBarOptionsBearRadio2:SetChecked(0)
	BadKittyBarOptionsBearRadio3:SetChecked(0)
	BadKittyBarOptionsBearRadio4:SetChecked(0)
	BadKittyBarOptionsBearRadio5:SetChecked(0)
	BadKittyBarOptionsBearRadio6:SetChecked(0)
	BadKittyBarOptionsBearRadio7:SetChecked(0)
end

function BadKitty_SetColor()
	local R,G,B = ColorPickerFrame:GetColorRGB()
	--BadKitty_Output(strsub(BadKittyColorTempFrame,21))
	getglobal("BadKitty"..strsub(BadKittyColorTempFrame,21).."Colors")[1] = R
	getglobal("BadKitty"..strsub(BadKittyColorTempFrame,21).."Colors")[2] = G
	getglobal("BadKitty"..strsub(BadKittyColorTempFrame,21).."Colors")[3] = B
	BadKitty_Colorize()
end 

function BadKitty_CancelColor(prevvals)
	local R,G,B = unpack(prevvals)
	getglobal("BadKitty"..strsub(BadKittyColorTempFrame,21).."Colors")[1] = R
	getglobal("BadKitty"..strsub(BadKittyColorTempFrame,21).."Colors")[2] = G
	getglobal("BadKitty"..strsub(BadKittyColorTempFrame,21).."Colors")[3] = B
end 

function BadKitty_Colorize()
	BadKittyCatSR:SetStatusBarColor(BadKittyCatSRColors[1],BadKittyCatSRColors[2],BadKittyCatSRColors[3])
	BadKittyCatMangle:SetStatusBarColor(BadKittyCatMangleColors[1],BadKittyCatMangleColors[2],BadKittyCatMangleColors[3])
	BadKittyCatRake:SetStatusBarColor(BadKittyCatRakeColors[1],BadKittyCatRakeColors[2],BadKittyCatRakeColors[3])
	BadKittyCatRip:SetStatusBarColor(BadKittyCatRipColors[1],BadKittyCatRipColors[2],BadKittyCatRipColors[3])
	BadKittyCatFFF:SetStatusBarColor(BadKittyCatFFFColors[1],BadKittyCatFFFColors[2],BadKittyCatFFFColors[3])
	BadKittyCatTF:SetStatusBarColor(BadKittyCatTFColors[1],BadKittyCatTFColors[2],BadKittyCatTFColors[3])
	BadKittyCatZerk:SetStatusBarColor(BadKittyCatZerkColors[1],BadKittyCatZerkColors[2],BadKittyCatZerkColors[3])
	BadKittyCatEnergy:SetStatusBarColor(BadKittyCatEnergyColors[1],BadKittyCatEnergyColors[2],BadKittyCatEnergyColors[3])
	BadKittyBearDemo:SetStatusBarColor(BadKittyBearDemoColors[1],BadKittyBearDemoColors[2],BadKittyBearDemoColors[3])
	BadKittyBearLac:SetStatusBarColor(BadKittyBearLacColors[1],BadKittyBearLacColors[2],BadKittyBearLacColors[3])
	BadKittyBearMangle:SetStatusBarColor(BadKittyBearMangleColors[1],BadKittyBearMangleColors[2],BadKittyBearMangleColors[3])
	BadKittyBearFFF:SetStatusBarColor(BadKittyBearFFFColors[1],BadKittyBearFFFColors[2],BadKittyBearFFFColors[3])
	BadKittyBearBS:SetStatusBarColor(BadKittyBearBSColors[1],BadKittyBearBSColors[2],BadKittyBearBSColors[3])
	BadKittyBearZerk:SetStatusBarColor(BadKittyBearZerkColors[1],BadKittyBearZerkColors[2],BadKittyBearZerkColors[3])
	BadKittyBearRage:SetStatusBarColor(BadKittyBearRageColors[1],BadKittyBearRageColors[2],BadKittyBearRageColors[3])
	
	BadKittyColorOptionsCatSRTexture:SetTexture(BadKittyCatSRColors[1],BadKittyCatSRColors[2],BadKittyCatSRColors[3])
	BadKittyColorOptionsCatMangleTexture:SetTexture(BadKittyCatMangleColors[1],BadKittyCatMangleColors[2],BadKittyCatMangleColors[3])
	BadKittyColorOptionsCatRakeTexture:SetTexture(BadKittyCatRakeColors[1],BadKittyCatRakeColors[2],BadKittyCatRakeColors[3])
	BadKittyColorOptionsCatRipTexture:SetTexture(BadKittyCatRipColors[1],BadKittyCatRipColors[2],BadKittyCatRipColors[3])
	BadKittyColorOptionsCatFFFTexture:SetTexture(BadKittyCatFFFColors[1],BadKittyCatFFFColors[2],BadKittyCatFFFColors[3])
	BadKittyColorOptionsCatTFTexture:SetTexture(BadKittyCatTFColors[1],BadKittyCatTFColors[2],BadKittyCatTFColors[3])
	BadKittyColorOptionsCatZerkTexture:SetTexture(BadKittyCatZerkColors[1],BadKittyCatZerkColors[2],BadKittyCatZerkColors[3])
	BadKittyColorOptionsCatEnergyTexture:SetTexture(BadKittyCatEnergyColors[1],BadKittyCatEnergyColors[2],BadKittyCatEnergyColors[3])
	BadKittyColorOptionsBearDemoTexture:SetTexture(BadKittyBearDemoColors[1],BadKittyBearDemoColors[2],BadKittyBearDemoColors[3])
	BadKittyColorOptionsBearLacTexture:SetTexture(BadKittyBearLacColors[1],BadKittyBearLacColors[2],BadKittyBearLacColors[3])
	BadKittyColorOptionsBearMangleTexture:SetTexture(BadKittyBearMangleColors[1],BadKittyBearMangleColors[2],BadKittyBearMangleColors[3])
	BadKittyColorOptionsBearFFFTexture:SetTexture(BadKittyBearFFFColors[1],BadKittyBearFFFColors[2],BadKittyBearFFFColors[3])
	BadKittyColorOptionsBearBSTexture:SetTexture(BadKittyBearBSColors[1],BadKittyBearBSColors[2],BadKittyBearBSColors[3])
	BadKittyColorOptionsBearZerkTexture:SetTexture(BadKittyBearZerkColors[1],BadKittyBearZerkColors[2],BadKittyBearZerkColors[3])
	BadKittyColorOptionsBearRageTexture:SetTexture(BadKittyBearRageColors[1],BadKittyBearRageColors[2],BadKittyBearRageColors[3])
	
end 